%global qt_module qtmultimedia

#global unstable 1
%if 0%{?unstable}
%global prerelease rc2
%endif

Summary: Qt6 - Multimedia support FFmpeg plugin
Name:    qt6-%{qt_module}-epel
Version: 6.8.1
Release: 1%{?dist}

License: LGPL-3.0-only OR GPL-3.0-only WITH Qt-GPL-exception-1.0
Url:     http://www.qt.io
%global  majmin %(echo %{version} | cut -d. -f1-2)
%global  qt_version %(echo %{version} | cut -d~ -f1)

%if 0%{?unstable}
Source0: https://download.qt.io/development_releases/qt/%{majmin}/%{qt_version}/submodules/%{qt_module}-everywhere-src-%{qt_version}-%{prerelease}.tar.xz
%else
Source0: https://download.qt.io/official_releases/qt/%{majmin}/%{version}/submodules/%{qt_module}-everywhere-src-%{version}.tar.xz
%endif

# filter plugin/qml provides
%global __provides_exclude_from ^(%{_qt6_archdatadir}/qml/.*\\.so|%{_qt6_plugindir}/.*\\.so)$

BuildRequires: cmake
BuildRequires: gcc-c++
BuildRequires: ninja-build
BuildRequires: qt6-rpm-macros
BuildRequires: qt6-qtbase-devel >= %{version}
BuildRequires: qt6-qtbase-private-devel
%{?_qt6:Requires: %{_qt6}%{?_isa} = %{_qt6_version}}
BuildRequires: qt6-qtdeclarative-devel >= %{version}
BuildRequires: qt6-qtshadertools-devel >= %{version}
BuildRequires: pkgconfig(alsa)
BuildRequires: pkgconfig(libpulse) pkgconfig(libpulse-mainloop-glib)
BuildRequires: ffmpeg-free-devel
BuildRequires: libavcodec-free-devel
BuildRequires: libavutil-free-devel
BuildRequires: libavformat-free-devel
BuildRequires: libswscale-free-devel
BuildRequires: libswresample-free-devel
BuildRequires: pkgconfig(libva) pkgconfig(libva-drm)
BuildRequires: pkgconfig(libpipewire-0.3)
BuildRequires: pkgconfig(xrandr)
BuildRequires: pkgconfig(xv)
BuildRequires: pkgconfig(xkbcommon) >= 0.5.0
BuildRequires: openssl-devel
# workaround missing dep
# /usr/include/gstreamer-1.0/gst/gl/wayland/gstgldisplay_wayland.h:26:10: fatal error: wayland-client.h: No such file or directory
BuildRequires: wayland-devel

Requires: qt6-qtmultimedia%{?_isa} = %{version}
Supplements: (qt6-qtmultimedia%{?_isa} = %{version} and libavcodec-free%{?_isa})

%description
The Qt Multimedia module provides a rich feature set that enables you to
easily take advantage of a platforms multimedia capabilites and hardware.
This ranges from the playback and recording of audio and video content to
the use of available devices like cameras and radios.

%prep
%autosetup -n %{qt_module}-everywhere-src-%{qt_version}%{?unstable:-%{prerelease}} -p1

#if "%%{_lib}" != "lib"
#sed -i -e 's|/lib/|/%%{_lib}/|g' cmake/FindFFmpeg.cmake
#endif


%build
%cmake_qt6 \
  -DQT_BUILD_EXAMPLES:BOOL=OFF \
  -DQT_BUILD_TESTS:BOOL=OFF

%cmake_build


%install
%cmake_install

# remove duplicate devel files
rm -fr %{buildroot}%{_qt6_headerdir}/
rm -f  %{buildroot}%{_qt6_libdir}/libQt6BundledResonanceAudio.a
rm -f  %{buildroot}%{_qt6_libdir}/libQt6Multimedia*
rm -f  %{buildroot}%{_qt6_libdir}/libQt6SpatialAudio*
rm -fr %{buildroot}%{_qt6_libdir}/cmake/Qt6/
rm -fr %{buildroot}%{_qt6_libdir}/cmake/Qt6BuildInternals/
rm -fr %{buildroot}%{_qt6_libdir}/cmake/Qt6BundledResonanceAudio/
rm -f  %{buildroot}%{_qt6_libdir}/cmake/Qt6Multimedia/Qt6Multimedia*
rm -fr %{buildroot}%{_qt6_libdir}/cmake/Qt6MultimediaQuick*
rm -fr %{buildroot}%{_qt6_libdir}/cmake/Qt6MultimediaTest*
rm -fr %{buildroot}%{_qt6_libdir}/cmake/Qt6MultimediaWidgets/
rm -fr %{buildroot}%{_qt6_libdir}/cmake/Qt6Qml*
rm -fr %{buildroot}%{_qt6_libdir}/cmake/Qt6SpatialAudio/
rm -f  %{buildroot}%{_qt6_archdatadir}/mkspecs/modules/*.pri
rm -f  %{buildroot}%{_qt6_libdir}/qt6/metatypes/qt6*_metatypes.json
rm -f  %{buildroot}%{_qt6_libdir}/qt6/modules/*.json
rm -f  %{buildroot}%{_qt6_libdir}/qt6/sbom/*.spdx
rm -f  %{buildroot}%{_qt6_libdir}/pkgconfig/*.pc
rm -fr %{buildroot}%{_qt6_qmldir}/QtMultimedia/


%files
%license LICENSES/*
%{_qt6_plugindir}/multimedia/libffmpegmediaplugin.so
%dir %{_qt6_libdir}/cmake/Qt6Multimedia
%{_qt6_libdir}/cmake/Qt6Multimedia/Qt6QFFmpegMediaPlugin*


%changelog
* Mon May 05 2025 Yaakov Selkowitz <yselkowitz@fedoraproject.org> - 6.8.1-1
- 6.8.1
